//var ServiceUri = "palm://com.palm.mobilehotspot";
var SysServiceUri = "palm://com.palm.systemservice";
var ServiceUri = "palm://org.webosinternals.freetether";
var FreeTetherService = Class.create({
  initialize: function() {
  },

  addInterface: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'interfaceAdd',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

  removeInterface: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'interfaceRemove',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

  getStatus: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'sysInfo',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

  getClientList: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'clientList',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

  monitorServer: function(name, callback) {
    var request = new Mojo.Service.Request('palm://com.palm.bus/signal', {
      method: 'registerServerStatus',
      parameters: {
        serviceName: name,
        subscribe: true,
      },
      onSuccess: callback,
      onFailure: callback
    });
  },
  
  getUSB: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'get_usb_gadget',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },
  
  setUSB: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'set_usb_gadget',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

  getPrefs: function(param, callback) {
    var request = new Mojo.Service.Request(SysServiceUri, {
      method: 'getPreferences',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },
  
  getIPForward: function(param, callback) {
    var request = new Mojo.Service.Request(ServiceUri, {
      method: 'get_ip_forward',
      parameters: param,
      onSuccess: callback,
      onFailure: callback
    });

    return request;
  },

});
